#include "ConsoleBinding.h"
#include "EventTargetBinding.h"
#include "PromiseBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WorkerDebuggerGlobalScopeBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkerDebuggerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!URLBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ConsoleBinding::ConstructorEnabled(aCx, aObj) && !ConsoleBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!EventTargetBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PromiseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!URLSearchParamsBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerDebuggerGlobalScopeBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

