//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layout/PVsyncParent.h"
#include "mozilla/TimeStamp.h"

#include "mozilla/ipc/PBackgroundParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace layout {


auto PVsyncParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PVsyncParent::PVsyncParent() :
    mId(0),
    mState(PVsync::__Dead)
{
    MOZ_COUNT_CTOR(PVsyncParent);
}

PVsyncParent::~PVsyncParent()
{
    MOZ_COUNT_DTOR(PVsyncParent);
}

auto PVsyncParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(mManager);
}

auto PVsyncParent::state() -> PVsync::State
{
    return mState;
}

auto PVsyncParent::SendNotify(const TimeStamp& aVsyncTimestamp) -> bool
{
    IPC::Message* msg__ = PVsync::Msg_Notify(mId);

    Write(aVsyncTimestamp, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
        mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Sending ", (msg__)->name(), mozilla::ipc::MessageDirection::eSending);
    }
    PROFILER_LABEL("IPDL::PVsync", "AsyncSendNotify", js::ProfileEntry::Category::OTHER);
    if ((!(PVsync::Transition(mState, Trigger(Trigger::Send, PVsync::Msg_Notify__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PVsyncParent::SendVsyncRate(const float& aVsyncRate) -> bool
{
    IPC::Message* msg__ = PVsync::Msg_VsyncRate(mId);

    Write(aVsyncRate, msg__);




    if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
        mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Sending ", (msg__)->name(), mozilla::ipc::MessageDirection::eSending);
    }
    PROFILER_LABEL("IPDL::PVsync", "AsyncSendVsyncRate", js::ProfileEntry::Category::OTHER);
    if ((!(PVsync::Transition(mState, Trigger(Trigger::Send, PVsync::Msg_VsyncRate__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool sendok__ = (mChannel)->Send(msg__);
    return sendok__;
}

auto PVsyncParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PVsyncParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PVsyncParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PVsyncParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PVsyncParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PVsyncParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PVsyncParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PVsyncParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PVsyncParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PVsyncParent::OtherPid() const -> base::ProcessId
{
    return (mManager)->OtherPid();
}

auto PVsyncParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PVsyncParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PVsyncParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    FatalError("Clone() for PVsync has not yet been implemented");
    return nullptr;
}

auto PVsyncParent::OnMessageReceived(const Message& msg__) -> PVsyncParent::Result
{
    switch ((msg__).type()) {
    case PVsync::Msg_Observe__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PVsync::Msg_Observe");
            if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
                mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Received ", ((&(msg__)))->name(), mozilla::ipc::MessageDirection::eReceiving);
            }
            PROFILER_LABEL("IPDL::PVsync", "RecvObserve", js::ProfileEntry::Category::OTHER);

            if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg_Observe__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvObserve()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Observe returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PVsync::Msg_Unobserve__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PVsync::Msg_Unobserve");
            if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
                mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Received ", ((&(msg__)))->name(), mozilla::ipc::MessageDirection::eReceiving);
            }
            PROFILER_LABEL("IPDL::PVsync", "RecvUnobserve", js::ProfileEntry::Category::OTHER);

            if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg_Unobserve__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvUnobserve()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Unobserve returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PVsync::Msg_RequestVsyncRate__ID:
        {
            (const_cast<Message&>(msg__)).set_name("PVsync::Msg_RequestVsyncRate");
            if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
                mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Received ", ((&(msg__)))->name(), mozilla::ipc::MessageDirection::eReceiving);
            }
            PROFILER_LABEL("IPDL::PVsync", "RecvRequestVsyncRate", js::ProfileEntry::Category::OTHER);

            if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg_RequestVsyncRate__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRequestVsyncRate()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for RequestVsyncRate returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PVsync::Msg___delete____ID:
        {
            (const_cast<Message&>(msg__)).set_name("PVsync::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PVsyncParent")) {
                mozilla::ipc::LogMessageForProtocol("PVsyncParent", OtherPid(), "Received ", ((&(msg__)))->name(), mozilla::ipc::MessageDirection::eReceiving);
            }
            PROFILER_LABEL("IPDL::PVsync", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* iter__ = nullptr;
            PVsyncParent* actor;

            if ((!(Read((&(actor)), (&(msg__)), (&(iter__)), false)))) {
                FatalError("Error deserializing 'PVsyncParent'");
                return MsgValueError;
            }
            (msg__).EndRead(iter__);
            if ((!(PVsync::Transition(mState, Trigger(Trigger::Recv, PVsync::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }


            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PVsyncMsgStart, actor);

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PVsyncParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PVsyncParent::Result
{
    return MsgNotKnown;
}

auto PVsyncParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PVsyncParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PVsyncParent::OnProcessingError(
        Result aCode,
        const char* aReason) -> void
{
    FatalError("`OnProcessingError' called on non-toplevel actor");
}

auto PVsyncParent::GetProtocolTypeId() -> int32_t
{
    return PVsyncMsgStart;
}

auto PVsyncParent::OnReplyTimeout() -> bool
{
    FatalError("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PVsyncParent::OnChannelClose() -> void
{
    FatalError("`OnClose' called on non-toplevel actor");
}

auto PVsyncParent::OnChannelError() -> void
{
    FatalError("`OnError' called on non-toplevel actor");
}

auto PVsyncParent::OnChannelConnected(int32_t aPid) -> void
{
    FatalError("'OnConnected' called on non-toplevel actor");
}

auto PVsyncParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PVsyncParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PVsyncParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PVsyncParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PVsyncParent", aMsg, true);
}

auto PVsyncParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PVsyncParent::DeallocSubtree() -> void
{
}

auto PVsyncParent::Write(
        PVsyncParent* v__,
        Message* msg__,
        bool nullable__) -> void
{
    int32_t id;
    if ((!(v__))) {
        if ((!(nullable__))) {
            FatalError("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (v__)->mId;
        if ((1) == (id)) {
            FatalError("actor has been |delete|d");
        }
    }

    Write(id, msg__);
}

auto PVsyncParent::Read(
        PVsyncParent** v__,
        const Message* msg__,
        void** iter__,
        bool nullable__) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), msg__, iter__)))) {
        FatalError("Error deserializing 'id' for 'PVsyncParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(nullable__))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PVsync");
        return false;
    }

    if ((0) == (id)) {
        (*(v__)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PVsync");
        return false;
    }

    if ((PVsyncMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PVsync has different type");
        return false;
    }

    (*(v__)) = static_cast<PVsyncParent*>(listener);
    return true;
}



} // namespace layout
} // namespace mozilla
