//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFMRadioRequest_h
#define PFMRadioRequest_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ErrorResponse|
//
namespace mozilla {
namespace dom {
class ErrorResponse final
{
private:

public:
    MOZ_IMPLICIT ErrorResponse();

    MOZ_IMPLICIT ErrorResponse(const nsString& _error)
    {
        Init();
        Assign(_error);
    }

    MOZ_IMPLICIT ErrorResponse(const ErrorResponse& _o)
    {
        Init();
        Assign((_o).error());
    }

    ~ErrorResponse();

    void
    operator=(const ErrorResponse& _o)
    {
        Assign((_o).error());
    }

    bool
    operator==(const ErrorResponse& _o) const;

    nsString&
    error()
    {
        return error_;
    }
    const nsString&
    error() const
    {
        return error_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _error);

    nsString error_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SuccessResponse|
//
namespace mozilla {
namespace dom {
class SuccessResponse final
{
private:

public:
    MOZ_IMPLICIT SuccessResponse()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT SuccessResponse(const SuccessResponse& _o)
    {
        Init();
        Assign();
    }

    ~SuccessResponse();

    void
    operator=(const SuccessResponse& _o)
    {
        Assign();
    }

    bool
    operator==(const SuccessResponse& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ErrorResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SuccessResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FMRadioResponseType|
//
namespace mozilla {
namespace dom {
class FMRadioResponseType final
{
public:
    enum Type {
        T__None,
        TErrorResponse = 1,
        TSuccessResponse,
        T__Last = TSuccessResponse
    };

private:
    typedef mozilla::dom::ErrorResponse ErrorResponse;
    typedef mozilla::dom::SuccessResponse SuccessResponse;
    typedef ErrorResponse ErrorResponse__tdef;
    typedef SuccessResponse SuccessResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<ErrorResponse> VErrorResponse;
        mozilla::AlignedStorage2<SuccessResponse> VSuccessResponse;
    };

    ErrorResponse*
    ptr_ErrorResponse()
    {
        return ((mValue).VErrorResponse).addr();
    }
    const ErrorResponse*
    constptr_ErrorResponse() const
    {
        return ((mValue).VErrorResponse).addr();
    }
    SuccessResponse*
    ptr_SuccessResponse()
    {
        return ((mValue).VSuccessResponse).addr();
    }
    const SuccessResponse*
    constptr_SuccessResponse() const
    {
        return ((mValue).VSuccessResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FMRadioResponseType() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FMRadioResponseType(const ErrorResponse& aOther);

    MOZ_IMPLICIT FMRadioResponseType(const SuccessResponse& aOther);

    MOZ_IMPLICIT FMRadioResponseType(const FMRadioResponseType& aOther);

    ~FMRadioResponseType();

    Type
    type() const
    {
        return mType;
    }

    FMRadioResponseType&
    operator=(const ErrorResponse& aRhs);

    FMRadioResponseType&
    operator=(const SuccessResponse& aRhs);

    FMRadioResponseType&
    operator=(const FMRadioResponseType& aRhs);

    bool
    operator==(const ErrorResponse& aRhs) const;

    bool
    operator==(const SuccessResponse& aRhs) const;

    bool
    operator==(const FMRadioResponseType& aRhs) const;

    ErrorResponse&
    get_ErrorResponse()
    {
        AssertSanity(TErrorResponse);
        return (*(ptr_ErrorResponse()));
    }
    const ErrorResponse&
    get_ErrorResponse() const
    {
        AssertSanity(TErrorResponse);
        return (*(constptr_ErrorResponse()));
    }
    operator ErrorResponse&()
    {
        return get_ErrorResponse();
    }
    operator const ErrorResponse&() const
    {
        return get_ErrorResponse();
    }

    SuccessResponse&
    get_SuccessResponse()
    {
        AssertSanity(TSuccessResponse);
        return (*(ptr_SuccessResponse()));
    }
    const SuccessResponse&
    get_SuccessResponse() const
    {
        AssertSanity(TSuccessResponse);
        return (*(constptr_SuccessResponse()));
    }
    operator SuccessResponse&()
    {
        return get_SuccessResponse();
    }
    operator const SuccessResponse&() const
    {
        return get_SuccessResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFMRadioRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PFMRadioRequestChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFMRadioRequestChild and PFMRadioRequestParent
//
namespace mozilla {
namespace dom {
namespace PFMRadioRequest {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PFMRadioRequestParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PFMRadioRequestChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PFMRadioRequestStart = PFMRadioRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PFMRadioRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PFMRadioRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PFMRadioRequest_h
