//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFileSystemParams_h
#define PFileSystemParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemCreateDirectoryParams|
//
namespace mozilla {
namespace dom {
class FileSystemCreateDirectoryParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemCreateDirectoryParams();

    MOZ_IMPLICIT FileSystemCreateDirectoryParams(
            const nsString& _filesystem,
            const nsString& _realPath)
    {
        Init();
        Assign(_filesystem, _realPath);
    }

    MOZ_IMPLICIT FileSystemCreateDirectoryParams(const FileSystemCreateDirectoryParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath());
    }

    ~FileSystemCreateDirectoryParams();

    void
    operator=(const FileSystemCreateDirectoryParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath());
    }

    bool
    operator==(const FileSystemCreateDirectoryParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath);

    nsString filesystem_;
    nsString realPath_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemFileDataValue|
//
namespace mozilla {
namespace dom {
class FileSystemFileDataValue final
{
public:
    enum Type {
        T__None,
        TArrayOfuint8_t = 1,
        TPBlobParent,
        TPBlobChild,
        T__Last = TPBlobChild
    };

private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef nsTArray<uint8_t> ArrayOfuint8_t__tdef;
    typedef PBlobParent* PBlobParent__tdef;
    typedef PBlobChild* PBlobChild__tdef;

    union Value {
        mozilla::AlignedStorage2<nsTArray<uint8_t>> VArrayOfuint8_t;
        mozilla::AlignedStorage2<PBlobParent*> VPBlobParent;
        mozilla::AlignedStorage2<PBlobChild*> VPBlobChild;
    };

    nsTArray<uint8_t>*
    ptr_ArrayOfuint8_t()
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    const nsTArray<uint8_t>*
    constptr_ArrayOfuint8_t() const
    {
        return ((mValue).VArrayOfuint8_t).addr();
    }
    PBlobParent**
    ptr_PBlobParent()
    {
        return ((mValue).VPBlobParent).addr();
    }
    PBlobParent* const*
    constptr_PBlobParent() const
    {
        return ((mValue).VPBlobParent).addr();
    }
    PBlobChild**
    ptr_PBlobChild()
    {
        return ((mValue).VPBlobChild).addr();
    }
    PBlobChild* const*
    constptr_PBlobChild() const
    {
        return ((mValue).VPBlobChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemFileDataValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemFileDataValue(const nsTArray<uint8_t>& aOther);

    MOZ_IMPLICIT FileSystemFileDataValue(PBlobParent* aOther);

    MOZ_IMPLICIT FileSystemFileDataValue(PBlobChild* aOther);

    MOZ_IMPLICIT FileSystemFileDataValue(const FileSystemFileDataValue& aOther);

    ~FileSystemFileDataValue();

    Type
    type() const
    {
        return mType;
    }

    FileSystemFileDataValue&
    operator=(const nsTArray<uint8_t>& aRhs);

    FileSystemFileDataValue&
    operator=(PBlobParent* aRhs);

    FileSystemFileDataValue&
    operator=(PBlobChild* aRhs);

    FileSystemFileDataValue&
    operator=(const FileSystemFileDataValue& aRhs);

    bool
    operator==(const nsTArray<uint8_t>& aRhs) const;

    bool
    operator==(PBlobParent* aRhs) const;

    bool
    operator==(PBlobChild* aRhs) const;

    bool
    operator==(const FileSystemFileDataValue& aRhs) const;

    nsTArray<uint8_t>&
    get_ArrayOfuint8_t()
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(ptr_ArrayOfuint8_t()));
    }
    const nsTArray<uint8_t>&
    get_ArrayOfuint8_t() const
    {
        AssertSanity(TArrayOfuint8_t);
        return (*(constptr_ArrayOfuint8_t()));
    }
    operator nsTArray<uint8_t>&()
    {
        return get_ArrayOfuint8_t();
    }
    operator const nsTArray<uint8_t>&() const
    {
        return get_ArrayOfuint8_t();
    }

    PBlobParent*&
    get_PBlobParent()
    {
        AssertSanity(TPBlobParent);
        return (*(ptr_PBlobParent()));
    }
    PBlobParent*
    get_PBlobParent() const
    {
        AssertSanity(TPBlobParent);
        return (*(constptr_PBlobParent()));
    }
    operator PBlobParent*&()
    {
        return get_PBlobParent();
    }
    operator PBlobParent*() const
    {
        return get_PBlobParent();
    }

    PBlobChild*&
    get_PBlobChild()
    {
        AssertSanity(TPBlobChild);
        return (*(ptr_PBlobChild()));
    }
    PBlobChild*
    get_PBlobChild() const
    {
        AssertSanity(TPBlobChild);
        return (*(constptr_PBlobChild()));
    }
    operator PBlobChild*&()
    {
        return get_PBlobChild();
    }
    operator PBlobChild*() const
    {
        return get_PBlobChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemFileDataValue;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemCreateFileParams|
//
namespace mozilla {
namespace dom {
class FileSystemCreateFileParams final
{
private:
    typedef mozilla::dom::FileSystemFileDataValue FileSystemFileDataValue;

public:
    MOZ_IMPLICIT FileSystemCreateFileParams();

    MOZ_IMPLICIT FileSystemCreateFileParams(
            const nsString& _filesystem,
            const nsString& _realPath,
            const FileSystemFileDataValue& _data,
            const bool& _replace)
    {
        Init();
        Assign(_filesystem, _realPath, _data, _replace);
    }

    MOZ_IMPLICIT FileSystemCreateFileParams(const FileSystemCreateFileParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath(), (_o).data(), (_o).replace());
    }

    ~FileSystemCreateFileParams();

    void
    operator=(const FileSystemCreateFileParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath(), (_o).data(), (_o).replace());
    }

    bool
    operator==(const FileSystemCreateFileParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

    FileSystemFileDataValue&
    data()
    {
        return data_;
    }
    const FileSystemFileDataValue&
    data() const
    {
        return data_;
    }

    bool&
    replace()
    {
        return replace_;
    }
    const bool&
    replace() const
    {
        return replace_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath,
            const FileSystemFileDataValue& _data,
            const bool& _replace);

    nsString filesystem_;
    nsString realPath_;
    FileSystemFileDataValue data_;
    bool replace_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetDirectoryListingParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetDirectoryListingParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetDirectoryListingParams();

    MOZ_IMPLICIT FileSystemGetDirectoryListingParams(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _filters)
    {
        Init();
        Assign(_filesystem, _realPath, _filters);
    }

    MOZ_IMPLICIT FileSystemGetDirectoryListingParams(const FileSystemGetDirectoryListingParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath(), (_o).filters());
    }

    ~FileSystemGetDirectoryListingParams();

    void
    operator=(const FileSystemGetDirectoryListingParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath(), (_o).filters());
    }

    bool
    operator==(const FileSystemGetDirectoryListingParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

    nsString&
    filters()
    {
        return filters_;
    }
    const nsString&
    filters() const
    {
        return filters_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath,
            const nsString& _filters);

    nsString filesystem_;
    nsString realPath_;
    nsString filters_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetFilesParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetFilesParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetFilesParams();

    MOZ_IMPLICIT FileSystemGetFilesParams(
            const nsString& _filesystem,
            const nsString& _realPath,
            const bool& _recursiveFlag)
    {
        Init();
        Assign(_filesystem, _realPath, _recursiveFlag);
    }

    MOZ_IMPLICIT FileSystemGetFilesParams(const FileSystemGetFilesParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath(), (_o).recursiveFlag());
    }

    ~FileSystemGetFilesParams();

    void
    operator=(const FileSystemGetFilesParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath(), (_o).recursiveFlag());
    }

    bool
    operator==(const FileSystemGetFilesParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

    bool&
    recursiveFlag()
    {
        return recursiveFlag_;
    }
    const bool&
    recursiveFlag() const
    {
        return recursiveFlag_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath,
            const bool& _recursiveFlag);

    nsString filesystem_;
    nsString realPath_;
    bool recursiveFlag_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemGetFileOrDirectoryParams|
//
namespace mozilla {
namespace dom {
class FileSystemGetFileOrDirectoryParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams();

    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams(
            const nsString& _filesystem,
            const nsString& _realPath)
    {
        Init();
        Assign(_filesystem, _realPath);
    }

    MOZ_IMPLICIT FileSystemGetFileOrDirectoryParams(const FileSystemGetFileOrDirectoryParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).realPath());
    }

    ~FileSystemGetFileOrDirectoryParams();

    void
    operator=(const FileSystemGetFileOrDirectoryParams& _o)
    {
        Assign((_o).filesystem(), (_o).realPath());
    }

    bool
    operator==(const FileSystemGetFileOrDirectoryParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _realPath);

    nsString filesystem_;
    nsString realPath_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemRemoveParams|
//
namespace mozilla {
namespace dom {
class FileSystemRemoveParams final
{
private:

public:
    MOZ_IMPLICIT FileSystemRemoveParams();

    MOZ_IMPLICIT FileSystemRemoveParams(
            const nsString& _filesystem,
            const nsString& _directory,
            const nsString& _targetDirectory,
            const bool& _recursive)
    {
        Init();
        Assign(_filesystem, _directory, _targetDirectory, _recursive);
    }

    MOZ_IMPLICIT FileSystemRemoveParams(const FileSystemRemoveParams& _o)
    {
        Init();
        Assign((_o).filesystem(), (_o).directory(), (_o).targetDirectory(), (_o).recursive());
    }

    ~FileSystemRemoveParams();

    void
    operator=(const FileSystemRemoveParams& _o)
    {
        Assign((_o).filesystem(), (_o).directory(), (_o).targetDirectory(), (_o).recursive());
    }

    bool
    operator==(const FileSystemRemoveParams& _o) const;

    nsString&
    filesystem()
    {
        return filesystem_;
    }
    const nsString&
    filesystem() const
    {
        return filesystem_;
    }

    nsString&
    directory()
    {
        return directory_;
    }
    const nsString&
    directory() const
    {
        return directory_;
    }

    nsString&
    targetDirectory()
    {
        return targetDirectory_;
    }
    const nsString&
    targetDirectory() const
    {
        return targetDirectory_;
    }

    bool&
    recursive()
    {
        return recursive_;
    }
    const bool&
    recursive() const
    {
        return recursive_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _filesystem,
            const nsString& _directory,
            const nsString& _targetDirectory,
            const bool& _recursive);

    nsString filesystem_;
    nsString directory_;
    nsString targetDirectory_;
    bool recursive_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemCreateDirectoryParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemCreateFileParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemGetDirectoryListingParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemGetFilesParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemGetFileOrDirectoryParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemRemoveParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemParams|
//
namespace mozilla {
namespace dom {
class FileSystemParams final
{
public:
    enum Type {
        T__None,
        TFileSystemCreateDirectoryParams = 1,
        TFileSystemCreateFileParams,
        TFileSystemGetDirectoryListingParams,
        TFileSystemGetFilesParams,
        TFileSystemGetFileOrDirectoryParams,
        TFileSystemRemoveParams,
        T__Last = TFileSystemRemoveParams
    };

private:
    typedef mozilla::dom::FileSystemCreateDirectoryParams FileSystemCreateDirectoryParams;
    typedef mozilla::dom::FileSystemCreateFileParams FileSystemCreateFileParams;
    typedef mozilla::dom::FileSystemGetDirectoryListingParams FileSystemGetDirectoryListingParams;
    typedef mozilla::dom::FileSystemGetFilesParams FileSystemGetFilesParams;
    typedef mozilla::dom::FileSystemGetFileOrDirectoryParams FileSystemGetFileOrDirectoryParams;
    typedef mozilla::dom::FileSystemRemoveParams FileSystemRemoveParams;
    typedef FileSystemCreateDirectoryParams FileSystemCreateDirectoryParams__tdef;
    typedef FileSystemCreateFileParams FileSystemCreateFileParams__tdef;
    typedef FileSystemGetDirectoryListingParams FileSystemGetDirectoryListingParams__tdef;
    typedef FileSystemGetFilesParams FileSystemGetFilesParams__tdef;
    typedef FileSystemGetFileOrDirectoryParams FileSystemGetFileOrDirectoryParams__tdef;
    typedef FileSystemRemoveParams FileSystemRemoveParams__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemCreateDirectoryParams> VFileSystemCreateDirectoryParams;
        mozilla::AlignedStorage2<FileSystemCreateFileParams> VFileSystemCreateFileParams;
        mozilla::AlignedStorage2<FileSystemGetDirectoryListingParams> VFileSystemGetDirectoryListingParams;
        mozilla::AlignedStorage2<FileSystemGetFilesParams> VFileSystemGetFilesParams;
        mozilla::AlignedStorage2<FileSystemGetFileOrDirectoryParams> VFileSystemGetFileOrDirectoryParams;
        mozilla::AlignedStorage2<FileSystemRemoveParams> VFileSystemRemoveParams;
    };

    FileSystemCreateDirectoryParams*
    ptr_FileSystemCreateDirectoryParams()
    {
        return ((mValue).VFileSystemCreateDirectoryParams).addr();
    }
    const FileSystemCreateDirectoryParams*
    constptr_FileSystemCreateDirectoryParams() const
    {
        return ((mValue).VFileSystemCreateDirectoryParams).addr();
    }
    FileSystemCreateFileParams*
    ptr_FileSystemCreateFileParams()
    {
        return ((mValue).VFileSystemCreateFileParams).addr();
    }
    const FileSystemCreateFileParams*
    constptr_FileSystemCreateFileParams() const
    {
        return ((mValue).VFileSystemCreateFileParams).addr();
    }
    FileSystemGetDirectoryListingParams*
    ptr_FileSystemGetDirectoryListingParams()
    {
        return ((mValue).VFileSystemGetDirectoryListingParams).addr();
    }
    const FileSystemGetDirectoryListingParams*
    constptr_FileSystemGetDirectoryListingParams() const
    {
        return ((mValue).VFileSystemGetDirectoryListingParams).addr();
    }
    FileSystemGetFilesParams*
    ptr_FileSystemGetFilesParams()
    {
        return ((mValue).VFileSystemGetFilesParams).addr();
    }
    const FileSystemGetFilesParams*
    constptr_FileSystemGetFilesParams() const
    {
        return ((mValue).VFileSystemGetFilesParams).addr();
    }
    FileSystemGetFileOrDirectoryParams*
    ptr_FileSystemGetFileOrDirectoryParams()
    {
        return ((mValue).VFileSystemGetFileOrDirectoryParams).addr();
    }
    const FileSystemGetFileOrDirectoryParams*
    constptr_FileSystemGetFileOrDirectoryParams() const
    {
        return ((mValue).VFileSystemGetFileOrDirectoryParams).addr();
    }
    FileSystemRemoveParams*
    ptr_FileSystemRemoveParams()
    {
        return ((mValue).VFileSystemRemoveParams).addr();
    }
    const FileSystemRemoveParams*
    constptr_FileSystemRemoveParams() const
    {
        return ((mValue).VFileSystemRemoveParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemParams(const FileSystemCreateDirectoryParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemCreateFileParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetDirectoryListingParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetFilesParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemGetFileOrDirectoryParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemRemoveParams& aOther);

    MOZ_IMPLICIT FileSystemParams(const FileSystemParams& aOther);

    ~FileSystemParams();

    Type
    type() const
    {
        return mType;
    }

    FileSystemParams&
    operator=(const FileSystemCreateDirectoryParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemCreateFileParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemGetDirectoryListingParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemGetFilesParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemGetFileOrDirectoryParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemRemoveParams& aRhs);

    FileSystemParams&
    operator=(const FileSystemParams& aRhs);

    bool
    operator==(const FileSystemCreateDirectoryParams& aRhs) const;

    bool
    operator==(const FileSystemCreateFileParams& aRhs) const;

    bool
    operator==(const FileSystemGetDirectoryListingParams& aRhs) const;

    bool
    operator==(const FileSystemGetFilesParams& aRhs) const;

    bool
    operator==(const FileSystemGetFileOrDirectoryParams& aRhs) const;

    bool
    operator==(const FileSystemRemoveParams& aRhs) const;

    bool
    operator==(const FileSystemParams& aRhs) const;

    FileSystemCreateDirectoryParams&
    get_FileSystemCreateDirectoryParams()
    {
        AssertSanity(TFileSystemCreateDirectoryParams);
        return (*(ptr_FileSystemCreateDirectoryParams()));
    }
    const FileSystemCreateDirectoryParams&
    get_FileSystemCreateDirectoryParams() const
    {
        AssertSanity(TFileSystemCreateDirectoryParams);
        return (*(constptr_FileSystemCreateDirectoryParams()));
    }
    operator FileSystemCreateDirectoryParams&()
    {
        return get_FileSystemCreateDirectoryParams();
    }
    operator const FileSystemCreateDirectoryParams&() const
    {
        return get_FileSystemCreateDirectoryParams();
    }

    FileSystemCreateFileParams&
    get_FileSystemCreateFileParams()
    {
        AssertSanity(TFileSystemCreateFileParams);
        return (*(ptr_FileSystemCreateFileParams()));
    }
    const FileSystemCreateFileParams&
    get_FileSystemCreateFileParams() const
    {
        AssertSanity(TFileSystemCreateFileParams);
        return (*(constptr_FileSystemCreateFileParams()));
    }
    operator FileSystemCreateFileParams&()
    {
        return get_FileSystemCreateFileParams();
    }
    operator const FileSystemCreateFileParams&() const
    {
        return get_FileSystemCreateFileParams();
    }

    FileSystemGetDirectoryListingParams&
    get_FileSystemGetDirectoryListingParams()
    {
        AssertSanity(TFileSystemGetDirectoryListingParams);
        return (*(ptr_FileSystemGetDirectoryListingParams()));
    }
    const FileSystemGetDirectoryListingParams&
    get_FileSystemGetDirectoryListingParams() const
    {
        AssertSanity(TFileSystemGetDirectoryListingParams);
        return (*(constptr_FileSystemGetDirectoryListingParams()));
    }
    operator FileSystemGetDirectoryListingParams&()
    {
        return get_FileSystemGetDirectoryListingParams();
    }
    operator const FileSystemGetDirectoryListingParams&() const
    {
        return get_FileSystemGetDirectoryListingParams();
    }

    FileSystemGetFilesParams&
    get_FileSystemGetFilesParams()
    {
        AssertSanity(TFileSystemGetFilesParams);
        return (*(ptr_FileSystemGetFilesParams()));
    }
    const FileSystemGetFilesParams&
    get_FileSystemGetFilesParams() const
    {
        AssertSanity(TFileSystemGetFilesParams);
        return (*(constptr_FileSystemGetFilesParams()));
    }
    operator FileSystemGetFilesParams&()
    {
        return get_FileSystemGetFilesParams();
    }
    operator const FileSystemGetFilesParams&() const
    {
        return get_FileSystemGetFilesParams();
    }

    FileSystemGetFileOrDirectoryParams&
    get_FileSystemGetFileOrDirectoryParams()
    {
        AssertSanity(TFileSystemGetFileOrDirectoryParams);
        return (*(ptr_FileSystemGetFileOrDirectoryParams()));
    }
    const FileSystemGetFileOrDirectoryParams&
    get_FileSystemGetFileOrDirectoryParams() const
    {
        AssertSanity(TFileSystemGetFileOrDirectoryParams);
        return (*(constptr_FileSystemGetFileOrDirectoryParams()));
    }
    operator FileSystemGetFileOrDirectoryParams&()
    {
        return get_FileSystemGetFileOrDirectoryParams();
    }
    operator const FileSystemGetFileOrDirectoryParams&() const
    {
        return get_FileSystemGetFileOrDirectoryParams();
    }

    FileSystemRemoveParams&
    get_FileSystemRemoveParams()
    {
        AssertSanity(TFileSystemRemoveParams);
        return (*(ptr_FileSystemRemoveParams()));
    }
    const FileSystemRemoveParams&
    get_FileSystemRemoveParams() const
    {
        AssertSanity(TFileSystemRemoveParams);
        return (*(constptr_FileSystemRemoveParams()));
    }
    operator FileSystemRemoveParams&()
    {
        return get_FileSystemRemoveParams();
    }
    operator const FileSystemRemoveParams&() const
    {
        return get_FileSystemRemoveParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef PFileSystemParams_h
