//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFileSystemRequest_h
#define PFileSystemRequest_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemFileResponse|
//
namespace mozilla {
namespace dom {
class FileSystemFileResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemFileResponse();

    MOZ_IMPLICIT FileSystemFileResponse(const nsString& _realPath)
    {
        Init();
        Assign(_realPath);
    }

    MOZ_IMPLICIT FileSystemFileResponse(const FileSystemFileResponse& _o)
    {
        Init();
        Assign((_o).realPath());
    }

    ~FileSystemFileResponse();

    void
    operator=(const FileSystemFileResponse& _o)
    {
        Assign((_o).realPath());
    }

    bool
    operator==(const FileSystemFileResponse& _o) const;

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _realPath);

    nsString realPath_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryResponse|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemDirectoryResponse();

    MOZ_IMPLICIT FileSystemDirectoryResponse(const nsString& _realPath)
    {
        Init();
        Assign(_realPath);
    }

    MOZ_IMPLICIT FileSystemDirectoryResponse(const FileSystemDirectoryResponse& _o)
    {
        Init();
        Assign((_o).realPath());
    }

    ~FileSystemDirectoryResponse();

    void
    operator=(const FileSystemDirectoryResponse& _o)
    {
        Assign((_o).realPath());
    }

    bool
    operator==(const FileSystemDirectoryResponse& _o) const;

    nsString&
    realPath()
    {
        return realPath_;
    }
    const nsString&
    realPath() const
    {
        return realPath_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _realPath);

    nsString realPath_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryListingResponseFile|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseFile final
{
private:

public:
    MOZ_IMPLICIT FileSystemDirectoryListingResponseFile();

    MOZ_IMPLICIT FileSystemDirectoryListingResponseFile(const nsString& _fileRealPath)
    {
        Init();
        Assign(_fileRealPath);
    }

    MOZ_IMPLICIT FileSystemDirectoryListingResponseFile(const FileSystemDirectoryListingResponseFile& _o)
    {
        Init();
        Assign((_o).fileRealPath());
    }

    ~FileSystemDirectoryListingResponseFile();

    void
    operator=(const FileSystemDirectoryListingResponseFile& _o)
    {
        Assign((_o).fileRealPath());
    }

    bool
    operator==(const FileSystemDirectoryListingResponseFile& _o) const;

    nsString&
    fileRealPath()
    {
        return fileRealPath_;
    }
    const nsString&
    fileRealPath() const
    {
        return fileRealPath_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _fileRealPath);

    nsString fileRealPath_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryListingResponseDirectory|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseDirectory final
{
private:

public:
    MOZ_IMPLICIT FileSystemDirectoryListingResponseDirectory();

    MOZ_IMPLICIT FileSystemDirectoryListingResponseDirectory(const nsString& _directoryRealPath)
    {
        Init();
        Assign(_directoryRealPath);
    }

    MOZ_IMPLICIT FileSystemDirectoryListingResponseDirectory(const FileSystemDirectoryListingResponseDirectory& _o)
    {
        Init();
        Assign((_o).directoryRealPath());
    }

    ~FileSystemDirectoryListingResponseDirectory();

    void
    operator=(const FileSystemDirectoryListingResponseDirectory& _o)
    {
        Assign((_o).directoryRealPath());
    }

    bool
    operator==(const FileSystemDirectoryListingResponseDirectory& _o) const;

    nsString&
    directoryRealPath()
    {
        return directoryRealPath_;
    }
    const nsString&
    directoryRealPath() const
    {
        return directoryRealPath_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _directoryRealPath);

    nsString directoryRealPath_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseFile;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseDirectory;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemDirectoryListingResponseData|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseData final
{
public:
    enum Type {
        T__None,
        TFileSystemDirectoryListingResponseFile = 1,
        TFileSystemDirectoryListingResponseDirectory,
        T__Last = TFileSystemDirectoryListingResponseDirectory
    };

private:
    typedef mozilla::dom::FileSystemDirectoryListingResponseFile FileSystemDirectoryListingResponseFile;
    typedef mozilla::dom::FileSystemDirectoryListingResponseDirectory FileSystemDirectoryListingResponseDirectory;
    typedef FileSystemDirectoryListingResponseFile FileSystemDirectoryListingResponseFile__tdef;
    typedef FileSystemDirectoryListingResponseDirectory FileSystemDirectoryListingResponseDirectory__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemDirectoryListingResponseFile> VFileSystemDirectoryListingResponseFile;
        mozilla::AlignedStorage2<FileSystemDirectoryListingResponseDirectory> VFileSystemDirectoryListingResponseDirectory;
    };

    FileSystemDirectoryListingResponseFile*
    ptr_FileSystemDirectoryListingResponseFile()
    {
        return ((mValue).VFileSystemDirectoryListingResponseFile).addr();
    }
    const FileSystemDirectoryListingResponseFile*
    constptr_FileSystemDirectoryListingResponseFile() const
    {
        return ((mValue).VFileSystemDirectoryListingResponseFile).addr();
    }
    FileSystemDirectoryListingResponseDirectory*
    ptr_FileSystemDirectoryListingResponseDirectory()
    {
        return ((mValue).VFileSystemDirectoryListingResponseDirectory).addr();
    }
    const FileSystemDirectoryListingResponseDirectory*
    constptr_FileSystemDirectoryListingResponseDirectory() const
    {
        return ((mValue).VFileSystemDirectoryListingResponseDirectory).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemDirectoryListingResponseData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemDirectoryListingResponseData(const FileSystemDirectoryListingResponseFile& aOther);

    MOZ_IMPLICIT FileSystemDirectoryListingResponseData(const FileSystemDirectoryListingResponseDirectory& aOther);

    MOZ_IMPLICIT FileSystemDirectoryListingResponseData(const FileSystemDirectoryListingResponseData& aOther);

    ~FileSystemDirectoryListingResponseData();

    Type
    type() const
    {
        return mType;
    }

    FileSystemDirectoryListingResponseData&
    operator=(const FileSystemDirectoryListingResponseFile& aRhs);

    FileSystemDirectoryListingResponseData&
    operator=(const FileSystemDirectoryListingResponseDirectory& aRhs);

    FileSystemDirectoryListingResponseData&
    operator=(const FileSystemDirectoryListingResponseData& aRhs);

    bool
    operator==(const FileSystemDirectoryListingResponseFile& aRhs) const;

    bool
    operator==(const FileSystemDirectoryListingResponseDirectory& aRhs) const;

    bool
    operator==(const FileSystemDirectoryListingResponseData& aRhs) const;

    FileSystemDirectoryListingResponseFile&
    get_FileSystemDirectoryListingResponseFile()
    {
        AssertSanity(TFileSystemDirectoryListingResponseFile);
        return (*(ptr_FileSystemDirectoryListingResponseFile()));
    }
    const FileSystemDirectoryListingResponseFile&
    get_FileSystemDirectoryListingResponseFile() const
    {
        AssertSanity(TFileSystemDirectoryListingResponseFile);
        return (*(constptr_FileSystemDirectoryListingResponseFile()));
    }
    operator FileSystemDirectoryListingResponseFile&()
    {
        return get_FileSystemDirectoryListingResponseFile();
    }
    operator const FileSystemDirectoryListingResponseFile&() const
    {
        return get_FileSystemDirectoryListingResponseFile();
    }

    FileSystemDirectoryListingResponseDirectory&
    get_FileSystemDirectoryListingResponseDirectory()
    {
        AssertSanity(TFileSystemDirectoryListingResponseDirectory);
        return (*(ptr_FileSystemDirectoryListingResponseDirectory()));
    }
    const FileSystemDirectoryListingResponseDirectory&
    get_FileSystemDirectoryListingResponseDirectory() const
    {
        AssertSanity(TFileSystemDirectoryListingResponseDirectory);
        return (*(constptr_FileSystemDirectoryListingResponseDirectory()));
    }
    operator FileSystemDirectoryListingResponseDirectory&()
    {
        return get_FileSystemDirectoryListingResponseDirectory();
    }
    operator const FileSystemDirectoryListingResponseDirectory&() const
    {
        return get_FileSystemDirectoryListingResponseDirectory();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponseData;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemDirectoryListingResponse|
//
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponse final
{
private:
    typedef mozilla::dom::FileSystemDirectoryListingResponseData FileSystemDirectoryListingResponseData;

public:
    MOZ_IMPLICIT FileSystemDirectoryListingResponse();

    MOZ_IMPLICIT FileSystemDirectoryListingResponse(const nsTArray<FileSystemDirectoryListingResponseData>& _data)
    {
        Init();
        Assign(_data);
    }

    MOZ_IMPLICIT FileSystemDirectoryListingResponse(const FileSystemDirectoryListingResponse& _o)
    {
        Init();
        Assign((_o).data());
    }

    ~FileSystemDirectoryListingResponse();

    void
    operator=(const FileSystemDirectoryListingResponse& _o)
    {
        Assign((_o).data());
    }

    bool
    operator==(const FileSystemDirectoryListingResponse& _o) const;

    nsTArray<FileSystemDirectoryListingResponseData>&
    data()
    {
        return data_;
    }
    const nsTArray<FileSystemDirectoryListingResponseData>&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<FileSystemDirectoryListingResponseData>& _data);

    nsTArray<FileSystemDirectoryListingResponseData> data_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemFileResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemFilesResponse|
//
namespace mozilla {
namespace dom {
class FileSystemFilesResponse final
{
private:
    typedef mozilla::dom::FileSystemFileResponse FileSystemFileResponse;

public:
    MOZ_IMPLICIT FileSystemFilesResponse();

    MOZ_IMPLICIT FileSystemFilesResponse(const nsTArray<FileSystemFileResponse>& _data)
    {
        Init();
        Assign(_data);
    }

    MOZ_IMPLICIT FileSystemFilesResponse(const FileSystemFilesResponse& _o)
    {
        Init();
        Assign((_o).data());
    }

    ~FileSystemFilesResponse();

    void
    operator=(const FileSystemFilesResponse& _o)
    {
        Assign((_o).data());
    }

    bool
    operator==(const FileSystemFilesResponse& _o) const;

    nsTArray<FileSystemFileResponse>&
    data()
    {
        return data_;
    }
    const nsTArray<FileSystemFileResponse>&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(const nsTArray<FileSystemFileResponse>& _data);

    nsTArray<FileSystemFileResponse> data_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemErrorResponse|
//
namespace mozilla {
namespace dom {
class FileSystemErrorResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemErrorResponse();

    MOZ_IMPLICIT FileSystemErrorResponse(const nsresult& _error)
    {
        Init();
        Assign(_error);
    }

    MOZ_IMPLICIT FileSystemErrorResponse(const FileSystemErrorResponse& _o)
    {
        Init();
        Assign((_o).error());
    }

    ~FileSystemErrorResponse();

    void
    operator=(const FileSystemErrorResponse& _o)
    {
        Assign((_o).error());
    }

    bool
    operator==(const FileSystemErrorResponse& _o) const;

    nsresult&
    error()
    {
        return error_;
    }
    const nsresult&
    error() const
    {
        return error_;
    }

private:
    void
    Init();

    void
    Assign(const nsresult& _error);

    nsresult error_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileSystemBooleanResponse|
//
namespace mozilla {
namespace dom {
class FileSystemBooleanResponse final
{
private:

public:
    MOZ_IMPLICIT FileSystemBooleanResponse();

    MOZ_IMPLICIT FileSystemBooleanResponse(const bool& _success)
    {
        Init();
        Assign(_success);
    }

    MOZ_IMPLICIT FileSystemBooleanResponse(const FileSystemBooleanResponse& _o)
    {
        Init();
        Assign((_o).success());
    }

    ~FileSystemBooleanResponse();

    void
    operator=(const FileSystemBooleanResponse& _o)
    {
        Assign((_o).success());
    }

    bool
    operator==(const FileSystemBooleanResponse& _o) const;

    bool&
    success()
    {
        return success_;
    }
    const bool&
    success() const
    {
        return success_;
    }

private:
    void
    Init();

    void
    Assign(const bool& _success);

    bool success_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class FileSystemBooleanResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemDirectoryResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemDirectoryListingResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemFileResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemFilesResponse;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileSystemErrorResponse;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FileSystemResponseValue|
//
namespace mozilla {
namespace dom {
class FileSystemResponseValue final
{
public:
    enum Type {
        T__None,
        TFileSystemBooleanResponse = 1,
        TFileSystemDirectoryResponse,
        TFileSystemDirectoryListingResponse,
        TFileSystemFileResponse,
        TFileSystemFilesResponse,
        TFileSystemErrorResponse,
        T__Last = TFileSystemErrorResponse
    };

private:
    typedef mozilla::dom::FileSystemBooleanResponse FileSystemBooleanResponse;
    typedef mozilla::dom::FileSystemDirectoryResponse FileSystemDirectoryResponse;
    typedef mozilla::dom::FileSystemDirectoryListingResponse FileSystemDirectoryListingResponse;
    typedef mozilla::dom::FileSystemFileResponse FileSystemFileResponse;
    typedef mozilla::dom::FileSystemFilesResponse FileSystemFilesResponse;
    typedef mozilla::dom::FileSystemErrorResponse FileSystemErrorResponse;
    typedef FileSystemBooleanResponse FileSystemBooleanResponse__tdef;
    typedef FileSystemDirectoryResponse FileSystemDirectoryResponse__tdef;
    typedef FileSystemDirectoryListingResponse FileSystemDirectoryListingResponse__tdef;
    typedef FileSystemFileResponse FileSystemFileResponse__tdef;
    typedef FileSystemFilesResponse FileSystemFilesResponse__tdef;
    typedef FileSystemErrorResponse FileSystemErrorResponse__tdef;

    union Value {
        mozilla::AlignedStorage2<FileSystemBooleanResponse> VFileSystemBooleanResponse;
        mozilla::AlignedStorage2<FileSystemDirectoryResponse> VFileSystemDirectoryResponse;
        mozilla::AlignedStorage2<FileSystemDirectoryListingResponse> VFileSystemDirectoryListingResponse;
        mozilla::AlignedStorage2<FileSystemFileResponse> VFileSystemFileResponse;
        mozilla::AlignedStorage2<FileSystemFilesResponse> VFileSystemFilesResponse;
        mozilla::AlignedStorage2<FileSystemErrorResponse> VFileSystemErrorResponse;
    };

    FileSystemBooleanResponse*
    ptr_FileSystemBooleanResponse()
    {
        return ((mValue).VFileSystemBooleanResponse).addr();
    }
    const FileSystemBooleanResponse*
    constptr_FileSystemBooleanResponse() const
    {
        return ((mValue).VFileSystemBooleanResponse).addr();
    }
    FileSystemDirectoryResponse*
    ptr_FileSystemDirectoryResponse()
    {
        return ((mValue).VFileSystemDirectoryResponse).addr();
    }
    const FileSystemDirectoryResponse*
    constptr_FileSystemDirectoryResponse() const
    {
        return ((mValue).VFileSystemDirectoryResponse).addr();
    }
    FileSystemDirectoryListingResponse*
    ptr_FileSystemDirectoryListingResponse()
    {
        return ((mValue).VFileSystemDirectoryListingResponse).addr();
    }
    const FileSystemDirectoryListingResponse*
    constptr_FileSystemDirectoryListingResponse() const
    {
        return ((mValue).VFileSystemDirectoryListingResponse).addr();
    }
    FileSystemFileResponse*
    ptr_FileSystemFileResponse()
    {
        return ((mValue).VFileSystemFileResponse).addr();
    }
    const FileSystemFileResponse*
    constptr_FileSystemFileResponse() const
    {
        return ((mValue).VFileSystemFileResponse).addr();
    }
    FileSystemFilesResponse*
    ptr_FileSystemFilesResponse()
    {
        return ((mValue).VFileSystemFilesResponse).addr();
    }
    const FileSystemFilesResponse*
    constptr_FileSystemFilesResponse() const
    {
        return ((mValue).VFileSystemFilesResponse).addr();
    }
    FileSystemErrorResponse*
    ptr_FileSystemErrorResponse()
    {
        return ((mValue).VFileSystemErrorResponse).addr();
    }
    const FileSystemErrorResponse*
    constptr_FileSystemErrorResponse() const
    {
        return ((mValue).VFileSystemErrorResponse).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FileSystemResponseValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemBooleanResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemDirectoryResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemDirectoryListingResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemFileResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemFilesResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemErrorResponse& aOther);

    MOZ_IMPLICIT FileSystemResponseValue(const FileSystemResponseValue& aOther);

    ~FileSystemResponseValue();

    Type
    type() const
    {
        return mType;
    }

    FileSystemResponseValue&
    operator=(const FileSystemBooleanResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemDirectoryResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemDirectoryListingResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemFileResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemFilesResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemErrorResponse& aRhs);

    FileSystemResponseValue&
    operator=(const FileSystemResponseValue& aRhs);

    bool
    operator==(const FileSystemBooleanResponse& aRhs) const;

    bool
    operator==(const FileSystemDirectoryResponse& aRhs) const;

    bool
    operator==(const FileSystemDirectoryListingResponse& aRhs) const;

    bool
    operator==(const FileSystemFileResponse& aRhs) const;

    bool
    operator==(const FileSystemFilesResponse& aRhs) const;

    bool
    operator==(const FileSystemErrorResponse& aRhs) const;

    bool
    operator==(const FileSystemResponseValue& aRhs) const;

    FileSystemBooleanResponse&
    get_FileSystemBooleanResponse()
    {
        AssertSanity(TFileSystemBooleanResponse);
        return (*(ptr_FileSystemBooleanResponse()));
    }
    const FileSystemBooleanResponse&
    get_FileSystemBooleanResponse() const
    {
        AssertSanity(TFileSystemBooleanResponse);
        return (*(constptr_FileSystemBooleanResponse()));
    }
    operator FileSystemBooleanResponse&()
    {
        return get_FileSystemBooleanResponse();
    }
    operator const FileSystemBooleanResponse&() const
    {
        return get_FileSystemBooleanResponse();
    }

    FileSystemDirectoryResponse&
    get_FileSystemDirectoryResponse()
    {
        AssertSanity(TFileSystemDirectoryResponse);
        return (*(ptr_FileSystemDirectoryResponse()));
    }
    const FileSystemDirectoryResponse&
    get_FileSystemDirectoryResponse() const
    {
        AssertSanity(TFileSystemDirectoryResponse);
        return (*(constptr_FileSystemDirectoryResponse()));
    }
    operator FileSystemDirectoryResponse&()
    {
        return get_FileSystemDirectoryResponse();
    }
    operator const FileSystemDirectoryResponse&() const
    {
        return get_FileSystemDirectoryResponse();
    }

    FileSystemDirectoryListingResponse&
    get_FileSystemDirectoryListingResponse()
    {
        AssertSanity(TFileSystemDirectoryListingResponse);
        return (*(ptr_FileSystemDirectoryListingResponse()));
    }
    const FileSystemDirectoryListingResponse&
    get_FileSystemDirectoryListingResponse() const
    {
        AssertSanity(TFileSystemDirectoryListingResponse);
        return (*(constptr_FileSystemDirectoryListingResponse()));
    }
    operator FileSystemDirectoryListingResponse&()
    {
        return get_FileSystemDirectoryListingResponse();
    }
    operator const FileSystemDirectoryListingResponse&() const
    {
        return get_FileSystemDirectoryListingResponse();
    }

    FileSystemFileResponse&
    get_FileSystemFileResponse()
    {
        AssertSanity(TFileSystemFileResponse);
        return (*(ptr_FileSystemFileResponse()));
    }
    const FileSystemFileResponse&
    get_FileSystemFileResponse() const
    {
        AssertSanity(TFileSystemFileResponse);
        return (*(constptr_FileSystemFileResponse()));
    }
    operator FileSystemFileResponse&()
    {
        return get_FileSystemFileResponse();
    }
    operator const FileSystemFileResponse&() const
    {
        return get_FileSystemFileResponse();
    }

    FileSystemFilesResponse&
    get_FileSystemFilesResponse()
    {
        AssertSanity(TFileSystemFilesResponse);
        return (*(ptr_FileSystemFilesResponse()));
    }
    const FileSystemFilesResponse&
    get_FileSystemFilesResponse() const
    {
        AssertSanity(TFileSystemFilesResponse);
        return (*(constptr_FileSystemFilesResponse()));
    }
    operator FileSystemFilesResponse&()
    {
        return get_FileSystemFilesResponse();
    }
    operator const FileSystemFilesResponse&() const
    {
        return get_FileSystemFilesResponse();
    }

    FileSystemErrorResponse&
    get_FileSystemErrorResponse()
    {
        AssertSanity(TFileSystemErrorResponse);
        return (*(ptr_FileSystemErrorResponse()));
    }
    const FileSystemErrorResponse&
    get_FileSystemErrorResponse() const
    {
        AssertSanity(TFileSystemErrorResponse);
        return (*(constptr_FileSystemErrorResponse()));
    }
    operator FileSystemErrorResponse&()
    {
        return get_FileSystemErrorResponse();
    }
    operator const FileSystemErrorResponse&() const
    {
        return get_FileSystemErrorResponse();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFileSystemRequestParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PFileSystemRequestChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PFileSystemRequestChild and PFileSystemRequestParent
//
namespace mozilla {
namespace dom {
namespace PFileSystemRequest {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PFileSystemRequestParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PFileSystemRequestChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PFileSystemRequestStart = PFileSystemRequestMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    PFileSystemRequestEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);



} // namespace PFileSystemRequest
} // namespace dom
} // namespace mozilla

#endif // ifndef PFileSystemRequest_h
