//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMessagePortParent_h
#define PMessagePortParent_h

#include "mozilla/dom/PMessagePort.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PMessagePortParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::ipc::PBackgroundParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::AnyBlobConstructorParams AnyBlobConstructorParams;
    typedef mozilla::dom::BlobConstructorParams BlobConstructorParams;
    typedef mozilla::dom::BlobData BlobData;
    typedef mozilla::dom::ChildBlobConstructorParams ChildBlobConstructorParams;
    typedef mozilla::dom::ClonedMessageData ClonedMessageData;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::dom::FileBlobConstructorParams FileBlobConstructorParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::IPCDataTransfer IPCDataTransfer;
    typedef mozilla::dom::IPCDataTransferData IPCDataTransferData;
    typedef mozilla::dom::IPCDataTransferImage IPCDataTransferImage;
    typedef mozilla::dom::IPCDataTransferItem IPCDataTransferItem;
    typedef mozilla::dom::KnownBlobConstructorParams KnownBlobConstructorParams;
    typedef mozilla::dom::MessagePortIdentifier MessagePortIdentifier;
    typedef mozilla::dom::MessagePortMessage MessagePortMessage;
    typedef mozilla::dom::MysteryBlobConstructorParams MysteryBlobConstructorParams;
    typedef mozilla::dom::NormalBlobConstructorParams NormalBlobConstructorParams;
    typedef mozilla::dom::OptionalBlobData OptionalBlobData;
    typedef mozilla::dom::OptionalID OptionalID;
    typedef mozilla::dom::ParentBlobConstructorParams ParentBlobConstructorParams;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::SameProcessBlobConstructorParams SameProcessBlobConstructorParams;
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::SlicedBlobConstructorParams SlicedBlobConstructorParams;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

    typedef PMessagePort::State State;

    virtual bool
    RecvPostMessages(nsTArray<MessagePortMessage>&& messages) = 0;
    virtual bool
    RecvDisentangle(nsTArray<MessagePortMessage>&& messages) = 0;
    virtual bool
    RecvStopSendingData() = 0;
    virtual bool
    RecvClose() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PMessagePortParent();

    virtual ~PMessagePortParent();

    PBackgroundParent*
    Manager() const;

    PMessagePort::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendEntangled(const nsTArray<MessagePortMessage>& messages);

    MOZ_WARN_UNUSED_RESULT bool
    SendReceiveData(const nsTArray<MessagePortMessage>& messages);

    MOZ_WARN_UNUSED_RESULT bool
    SendStopSendingDataConfirmed();

    MOZ_WARN_UNUSED_RESULT static bool
    Send__delete__(PMessagePortParent* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<MessagePortMessage>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<MessagePortMessage>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const MessagePortMessage& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MessagePortMessage* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<MessagePortIdentifier>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<MessagePortIdentifier>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            const nsTArray<PBlobParent*>& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            nsTArray<PBlobParent*>* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PMessagePortParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PMessagePortParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    void
    Write(
            const MessagePortIdentifier& v__,
            Message* msg__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            MessagePortIdentifier* v__,
            const Message* msg__,
            void** iter__);

    void
    Write(
            PBlobParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PBlobParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class MessagePortParent :
    public PMessagePortParent
{
    virtual bool
    RecvPostMessages(nsTArray<MessagePortMessage>&& messages);

    virtual bool
    RecvDisentangle(nsTArray<MessagePortMessage>&& messages);

    virtual bool
    RecvStopSendingData();

    virtual bool
    RecvClose();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT MessagePortParent();
    virtual ~MessagePortParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
MessagePortParent::RecvPostMessages(nsTArray<MessagePortMessage>&& messages)
{
    return false;
}

bool
MessagePortParent::RecvDisentangle(nsTArray<MessagePortMessage>&& messages)
{
    return false;
}

bool
MessagePortParent::RecvStopSendingData()
{
    return false;
}

bool
MessagePortParent::RecvClose()
{
    return false;
}

void
MessagePortParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT MessagePortParent::MessagePortParent()
{
    MOZ_COUNT_CTOR(MessagePortParent);
}

MOZ_IMPLICIT MessagePortParent::~MessagePortParent()
{
    MOZ_COUNT_DTOR(MessagePortParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PMessagePortParent_h
