//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PPresentation_h
#define PPresentation_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/ipc/InputStreamParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StartSessionRequest|
//
namespace mozilla {
namespace dom {
class StartSessionRequest final
{
private:

public:
    MOZ_IMPLICIT StartSessionRequest();

    MOZ_IMPLICIT StartSessionRequest(
            const nsString& _url,
            const nsString& _sessionId,
            const nsString& _origin,
            const nsString& _deviceId)
    {
        Init();
        Assign(_url, _sessionId, _origin, _deviceId);
    }

    MOZ_IMPLICIT StartSessionRequest(const StartSessionRequest& _o)
    {
        Init();
        Assign((_o).url(), (_o).sessionId(), (_o).origin(), (_o).deviceId());
    }

    ~StartSessionRequest();

    void
    operator=(const StartSessionRequest& _o)
    {
        Assign((_o).url(), (_o).sessionId(), (_o).origin(), (_o).deviceId());
    }

    bool
    operator==(const StartSessionRequest& _o) const;

    nsString&
    url()
    {
        return url_;
    }
    const nsString&
    url() const
    {
        return url_;
    }

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

    nsString&
    origin()
    {
        return origin_;
    }
    const nsString&
    origin() const
    {
        return origin_;
    }

    nsString&
    deviceId()
    {
        return deviceId_;
    }
    const nsString&
    deviceId() const
    {
        return deviceId_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _url,
            const nsString& _sessionId,
            const nsString& _origin,
            const nsString& _deviceId);

    nsString url_;
    nsString sessionId_;
    nsString origin_;
    nsString deviceId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SendSessionMessageRequest|
//
namespace mozilla {
namespace dom {
class SendSessionMessageRequest final
{
private:

public:
    MOZ_IMPLICIT SendSessionMessageRequest();

    MOZ_IMPLICIT SendSessionMessageRequest(
            const nsString& _sessionId,
            const nsString& _data)
    {
        Init();
        Assign(_sessionId, _data);
    }

    MOZ_IMPLICIT SendSessionMessageRequest(const SendSessionMessageRequest& _o)
    {
        Init();
        Assign((_o).sessionId(), (_o).data());
    }

    ~SendSessionMessageRequest();

    void
    operator=(const SendSessionMessageRequest& _o)
    {
        Assign((_o).sessionId(), (_o).data());
    }

    bool
    operator==(const SendSessionMessageRequest& _o) const;

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

    nsString&
    data()
    {
        return data_;
    }
    const nsString&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _sessionId,
            const nsString& _data);

    nsString sessionId_;
    nsString data_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CloseSessionRequest|
//
namespace mozilla {
namespace dom {
class CloseSessionRequest final
{
private:

public:
    MOZ_IMPLICIT CloseSessionRequest();

    MOZ_IMPLICIT CloseSessionRequest(const nsString& _sessionId)
    {
        Init();
        Assign(_sessionId);
    }

    MOZ_IMPLICIT CloseSessionRequest(const CloseSessionRequest& _o)
    {
        Init();
        Assign((_o).sessionId());
    }

    ~CloseSessionRequest();

    void
    operator=(const CloseSessionRequest& _o)
    {
        Assign((_o).sessionId());
    }

    bool
    operator==(const CloseSessionRequest& _o) const;

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _sessionId);

    nsString sessionId_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TerminateSessionRequest|
//
namespace mozilla {
namespace dom {
class TerminateSessionRequest final
{
private:

public:
    MOZ_IMPLICIT TerminateSessionRequest();

    MOZ_IMPLICIT TerminateSessionRequest(const nsString& _sessionId)
    {
        Init();
        Assign(_sessionId);
    }

    MOZ_IMPLICIT TerminateSessionRequest(const TerminateSessionRequest& _o)
    {
        Init();
        Assign((_o).sessionId());
    }

    ~TerminateSessionRequest();

    void
    operator=(const TerminateSessionRequest& _o)
    {
        Assign((_o).sessionId());
    }

    bool
    operator==(const TerminateSessionRequest& _o) const;

    nsString&
    sessionId()
    {
        return sessionId_;
    }
    const nsString&
    sessionId() const
    {
        return sessionId_;
    }

private:
    void
    Init();

    void
    Assign(const nsString& _sessionId);

    nsString sessionId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class StartSessionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SendSessionMessageRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class CloseSessionRequest;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class TerminateSessionRequest;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union PresentationIPCRequest|
//
namespace mozilla {
namespace dom {
class PresentationIPCRequest final
{
public:
    enum Type {
        T__None,
        TStartSessionRequest = 1,
        TSendSessionMessageRequest,
        TCloseSessionRequest,
        TTerminateSessionRequest,
        T__Last = TTerminateSessionRequest
    };

private:
    typedef mozilla::dom::StartSessionRequest StartSessionRequest;
    typedef mozilla::dom::SendSessionMessageRequest SendSessionMessageRequest;
    typedef mozilla::dom::CloseSessionRequest CloseSessionRequest;
    typedef mozilla::dom::TerminateSessionRequest TerminateSessionRequest;
    typedef StartSessionRequest StartSessionRequest__tdef;
    typedef SendSessionMessageRequest SendSessionMessageRequest__tdef;
    typedef CloseSessionRequest CloseSessionRequest__tdef;
    typedef TerminateSessionRequest TerminateSessionRequest__tdef;

    union Value {
        mozilla::AlignedStorage2<StartSessionRequest> VStartSessionRequest;
        mozilla::AlignedStorage2<SendSessionMessageRequest> VSendSessionMessageRequest;
        mozilla::AlignedStorage2<CloseSessionRequest> VCloseSessionRequest;
        mozilla::AlignedStorage2<TerminateSessionRequest> VTerminateSessionRequest;
    };

    StartSessionRequest*
    ptr_StartSessionRequest()
    {
        return ((mValue).VStartSessionRequest).addr();
    }
    const StartSessionRequest*
    constptr_StartSessionRequest() const
    {
        return ((mValue).VStartSessionRequest).addr();
    }
    SendSessionMessageRequest*
    ptr_SendSessionMessageRequest()
    {
        return ((mValue).VSendSessionMessageRequest).addr();
    }
    const SendSessionMessageRequest*
    constptr_SendSessionMessageRequest() const
    {
        return ((mValue).VSendSessionMessageRequest).addr();
    }
    CloseSessionRequest*
    ptr_CloseSessionRequest()
    {
        return ((mValue).VCloseSessionRequest).addr();
    }
    const CloseSessionRequest*
    constptr_CloseSessionRequest() const
    {
        return ((mValue).VCloseSessionRequest).addr();
    }
    TerminateSessionRequest*
    ptr_TerminateSessionRequest()
    {
        return ((mValue).VTerminateSessionRequest).addr();
    }
    const TerminateSessionRequest*
    constptr_TerminateSessionRequest() const
    {
        return ((mValue).VTerminateSessionRequest).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_DIAGNOSTIC_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_DIAGNOSTIC_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_DIAGNOSTIC_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT PresentationIPCRequest() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT PresentationIPCRequest(const StartSessionRequest& aOther);

    MOZ_IMPLICIT PresentationIPCRequest(const SendSessionMessageRequest& aOther);

    MOZ_IMPLICIT PresentationIPCRequest(const CloseSessionRequest& aOther);

    MOZ_IMPLICIT PresentationIPCRequest(const TerminateSessionRequest& aOther);

    MOZ_IMPLICIT PresentationIPCRequest(const PresentationIPCRequest& aOther);

    ~PresentationIPCRequest();

    Type
    type() const
    {
        return mType;
    }

    PresentationIPCRequest&
    operator=(const StartSessionRequest& aRhs);

    PresentationIPCRequest&
    operator=(const SendSessionMessageRequest& aRhs);

    PresentationIPCRequest&
    operator=(const CloseSessionRequest& aRhs);

    PresentationIPCRequest&
    operator=(const TerminateSessionRequest& aRhs);

    PresentationIPCRequest&
    operator=(const PresentationIPCRequest& aRhs);

    bool
    operator==(const StartSessionRequest& aRhs) const;

    bool
    operator==(const SendSessionMessageRequest& aRhs) const;

    bool
    operator==(const CloseSessionRequest& aRhs) const;

    bool
    operator==(const TerminateSessionRequest& aRhs) const;

    bool
    operator==(const PresentationIPCRequest& aRhs) const;

    StartSessionRequest&
    get_StartSessionRequest()
    {
        AssertSanity(TStartSessionRequest);
        return (*(ptr_StartSessionRequest()));
    }
    const StartSessionRequest&
    get_StartSessionRequest() const
    {
        AssertSanity(TStartSessionRequest);
        return (*(constptr_StartSessionRequest()));
    }
    operator StartSessionRequest&()
    {
        return get_StartSessionRequest();
    }
    operator const StartSessionRequest&() const
    {
        return get_StartSessionRequest();
    }

    SendSessionMessageRequest&
    get_SendSessionMessageRequest()
    {
        AssertSanity(TSendSessionMessageRequest);
        return (*(ptr_SendSessionMessageRequest()));
    }
    const SendSessionMessageRequest&
    get_SendSessionMessageRequest() const
    {
        AssertSanity(TSendSessionMessageRequest);
        return (*(constptr_SendSessionMessageRequest()));
    }
    operator SendSessionMessageRequest&()
    {
        return get_SendSessionMessageRequest();
    }
    operator const SendSessionMessageRequest&() const
    {
        return get_SendSessionMessageRequest();
    }

    CloseSessionRequest&
    get_CloseSessionRequest()
    {
        AssertSanity(TCloseSessionRequest);
        return (*(ptr_CloseSessionRequest()));
    }
    const CloseSessionRequest&
    get_CloseSessionRequest() const
    {
        AssertSanity(TCloseSessionRequest);
        return (*(constptr_CloseSessionRequest()));
    }
    operator CloseSessionRequest&()
    {
        return get_CloseSessionRequest();
    }
    operator const CloseSessionRequest&() const
    {
        return get_CloseSessionRequest();
    }

    TerminateSessionRequest&
    get_TerminateSessionRequest()
    {
        AssertSanity(TTerminateSessionRequest);
        return (*(ptr_TerminateSessionRequest()));
    }
    const TerminateSessionRequest&
    get_TerminateSessionRequest() const
    {
        AssertSanity(TTerminateSessionRequest);
        return (*(constptr_TerminateSessionRequest()));
    }
    operator TerminateSessionRequest&()
    {
        return get_TerminateSessionRequest();
    }
    operator const TerminateSessionRequest&() const
    {
        return get_TerminateSessionRequest();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PPresentationParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PPresentationChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PPresentationChild and PPresentationParent
//
namespace mozilla {
namespace dom {
namespace PPresentation {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PPresentationParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PPresentationChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PPresentationStart = PPresentationMsgStart << 16,
    Msg_NotifyAvailableChange__ID,
    Msg_NotifySessionStateChange__ID,
    Msg_NotifyMessage__ID,
    Msg_NotifySessionConnect__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RegisterAvailabilityHandler__ID,
    Msg_UnregisterAvailabilityHandler__ID,
    Msg_RegisterSessionHandler__ID,
    Msg_UnregisterSessionHandler__ID,
    Msg_RegisterRespondingHandler__ID,
    Msg_UnregisterRespondingHandler__ID,
    Msg_PPresentationRequestConstructor__ID,
    Reply_PPresentationRequestConstructor__ID,
    Msg_NotifyReceiverReady__ID,
    PPresentationEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_NotifyAvailableChange(int32_t routingId);

IPC::Message*
Msg_NotifySessionStateChange(int32_t routingId);

IPC::Message*
Msg_NotifyMessage(int32_t routingId);

IPC::Message*
Msg_NotifySessionConnect(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_RegisterAvailabilityHandler(int32_t routingId);

IPC::Message*
Msg_UnregisterAvailabilityHandler(int32_t routingId);

IPC::Message*
Msg_RegisterSessionHandler(int32_t routingId);

IPC::Message*
Msg_UnregisterSessionHandler(int32_t routingId);

IPC::Message*
Msg_RegisterRespondingHandler(int32_t routingId);

IPC::Message*
Msg_UnregisterRespondingHandler(int32_t routingId);

IPC::Message*
Msg_PPresentationRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PPresentationRequestConstructor(int32_t routingId);

IPC::Message*
Msg_NotifyReceiverReady(int32_t routingId);



} // namespace PPresentation
} // namespace dom
} // namespace mozilla

#endif // ifndef PPresentation_h
