//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PVRManagerParent_h
#define PVRManagerParent_h

#include "mozilla/gfx/PVRManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "VRMessageUtils.h"

namespace mozilla {
namespace gfx {
struct VRFieldOfView;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
struct VRDeviceUpdate;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
struct VRSensorUpdate;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {


class PVRManagerParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>,
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gfx::VRDeviceUpdate VRDeviceUpdate;
    typedef mozilla::gfx::VRFieldOfView VRFieldOfView;
    typedef mozilla::gfx::VRSensorUpdate VRSensorUpdate;

    typedef PVRManager::State State;

    virtual bool
    RecvRefreshDevices() = 0;
    virtual bool
    RecvResetSensor(const uint32_t& aDeviceID) = 0;
    virtual bool
    RecvKeepSensorTracking(const uint32_t& aDeviceID) = 0;
    virtual bool
    RecvSetFOV(
            const uint32_t& aDeviceID,
            const VRFieldOfView& aFOVLeft,
            const VRFieldOfView& aFOVRight,
            const double& zNear,
            const double& zFar) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PVRManagerParent();

    virtual ~PVRManagerParent();

    bool
    Open(
            Channel::Transport* aTransport,
            base::ProcessId aOtherPid,
            MessageLoop* aThread = nullptr,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    bool
    Open(
            MessageChannel* aChannel,
            MessageLoop* aMessageLoop,
            mozilla::ipc::Side aSide = mozilla::ipc::UnknownSide);

    void
    Close();

    void
    SetReplyTimeoutMs(int32_t aTimeoutMs);

    PVRManager::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendUpdateDeviceInfo(const nsTArray<VRDeviceUpdate>& aDeviceUpdates);

    MOZ_WARN_UNUSED_RESULT bool
    SendUpdateDeviceSensors(const nsTArray<VRSensorUpdate>& aDeviceSensorUpdates);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnEnteredCxxStack();
    void
    OnExitedCxxStack();
    void
    OnEnteredCall();
    void
    OnExitedCall();
    bool
    IsOnCxxStack() const;
    void
    FlushPendingInterruptQueue();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

    void
    SetOtherProcessId(base::ProcessId aOtherPid);

protected:
    bool
    TakeMinidump(
            nsIFile** aDump,
            uint32_t* aSequence) const;

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    void
    DeallocShmems();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    Channel mChannel;
    IDMap<ProtocolBase> mActorMap;
    int32_t mLastRouteId;
    base::ProcessId mOtherPid;
    IDMap<Shmem::SharedMemory> mShmemMap;
    Shmem::id_t mLastShmemId;
    State mState;
};


} // namespace gfx
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gfx {
class VRManagerParent :
    public PVRManagerParent
{
    virtual bool
    RecvRefreshDevices();

    virtual bool
    RecvResetSensor(const uint32_t& aDeviceID);

    virtual bool
    RecvKeepSensorTracking(const uint32_t& aDeviceID);

    virtual bool
    RecvSetFOV(
            const uint32_t& aDeviceID,
            const VRFieldOfView& aFOVLeft,
            const VRFieldOfView& aFOVRight,
            const double& zNear,
            const double& zFar);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT VRManagerParent();
    virtual ~VRManagerParent();
};
} // namespace gfx
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gfx {
bool
VRManagerParent::RecvRefreshDevices()
{
    return false;
}

bool
VRManagerParent::RecvResetSensor(const uint32_t& aDeviceID)
{
    return false;
}

bool
VRManagerParent::RecvKeepSensorTracking(const uint32_t& aDeviceID)
{
    return false;
}

bool
VRManagerParent::RecvSetFOV(
        const uint32_t& aDeviceID,
        const VRFieldOfView& aFOVLeft,
        const VRFieldOfView& aFOVRight,
        const double& zNear,
        const double& zFar)
{
    return false;
}

void
VRManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT VRManagerParent::VRManagerParent()
{
    MOZ_COUNT_CTOR(VRManagerParent);
}

MOZ_IMPLICIT VRManagerParent::~VRManagerParent()
{
    MOZ_COUNT_DTOR(VRManagerParent);
}

} // namespace gfx
} // namespace mozilla
#endif // if 0

#endif // ifndef PVRManagerParent_h
