//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZChild_h
#define PAPZChild_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "Units.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace layers {
struct FrameMetrics;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::layers::GeckoContentController::APZStateChange APZStateChange;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::CSSPoint CSSPoint;
    typedef mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;

    typedef PAPZ::State State;

    virtual bool
    RecvUpdateFrame(const FrameMetrics& frame) = 0;
    virtual bool
    RecvHandleDoubleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid) = 0;
    virtual bool
    RecvHandleSingleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const bool& aCallTakeFocusForClickFromTap) = 0;
    virtual bool
    RecvHandleLongTap(
            const CSSPoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId) = 0;
    virtual bool
    RecvNotifyAPZStateChange(
            const ViewID& aViewId,
            const APZStateChange& aChange,
            const int& aArg) = 0;
    virtual bool
    RecvNotifyFlushComplete() = 0;
    virtual bool
    RecvDestroy() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PAPZChild();

    virtual ~PAPZChild();

    PContentChild*
    Manager() const;

    PAPZ::State
    state();

    bool
    SendUpdateHitRegion(const nsRegion& aRegion);

    bool
    SendZoomToRect(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const CSSRect& aRect,
            const uint32_t& aFlags);

    bool
    SendContentReceivedInputBlock(
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId,
            const bool& aPreventDefault);

    bool
    SendSetTargetAPZC(
            const uint64_t& aInputBlockId,
            const nsTArray<ScrollableLayerGuid>& aTargets);

    bool
    SendStartScrollbarDrag(const AsyncDragMetrics& aDragMetrics);

    bool
    SendSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            const nsTArray<TouchBehaviorFlags>& aFlags);

    bool
    SendUpdateZoomConstraints(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const MaybeZoomConstraints& aConstraints);

    static bool
    Send__delete__(PAPZChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PAPZChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PAPZChild** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZChild :
    public PAPZChild
{
    virtual bool
    RecvUpdateFrame(const FrameMetrics& frame);

    virtual bool
    RecvHandleDoubleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid);

    virtual bool
    RecvHandleSingleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const bool& aCallTakeFocusForClickFromTap);

    virtual bool
    RecvHandleLongTap(
            const CSSPoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId);

    virtual bool
    RecvNotifyAPZStateChange(
            const ViewID& aViewId,
            const APZStateChange& aChange,
            const int& aArg);

    virtual bool
    RecvNotifyFlushComplete();

    virtual bool
    RecvDestroy();

    MOZ_IMPLICIT APZChild();
    virtual ~APZChild();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
bool
APZChild::RecvUpdateFrame(const FrameMetrics& frame)
{
    return false;
}

bool
APZChild::RecvHandleDoubleTap(
        const CSSPoint& aPoint,
        const Modifiers& aModifiers,
        const ScrollableLayerGuid& aGuid)
{
    return false;
}

bool
APZChild::RecvHandleSingleTap(
        const CSSPoint& aPoint,
        const Modifiers& aModifiers,
        const ScrollableLayerGuid& aGuid,
        const bool& aCallTakeFocusForClickFromTap)
{
    return false;
}

bool
APZChild::RecvHandleLongTap(
        const CSSPoint& point,
        const Modifiers& aModifiers,
        const ScrollableLayerGuid& aGuid,
        const uint64_t& aInputBlockId)
{
    return false;
}

bool
APZChild::RecvNotifyAPZStateChange(
        const ViewID& aViewId,
        const APZStateChange& aChange,
        const int& aArg)
{
    return false;
}

bool
APZChild::RecvNotifyFlushComplete()
{
    return false;
}

bool
APZChild::RecvDestroy()
{
    return false;
}

MOZ_IMPLICIT APZChild::APZChild()
{
    MOZ_COUNT_CTOR(APZChild);
}

MOZ_IMPLICIT APZChild::~APZChild()
{
    MOZ_COUNT_DTOR(APZChild);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZChild_h
