//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZParent_h
#define PAPZParent_h

#include "mozilla/layers/PAPZ.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "Units.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace layers {
struct FrameMetrics;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

class nsRegion;

namespace mozilla {
namespace layers {


class PAPZParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::layers::GeckoContentController::APZStateChange APZStateChange;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::CSSPoint CSSPoint;
    typedef mozilla::dom::ContentParentId ContentParentId;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::layers::FrameMetrics FrameMetrics;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PAPZ::State State;

    virtual bool
    RecvUpdateHitRegion(const nsRegion& aRegion) = 0;
    virtual bool
    RecvZoomToRect(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const CSSRect& aRect,
            const uint32_t& aFlags) = 0;
    virtual bool
    RecvContentReceivedInputBlock(
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId,
            const bool& aPreventDefault) = 0;
    virtual bool
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& aTargets) = 0;
    virtual bool
    RecvStartScrollbarDrag(const AsyncDragMetrics& aDragMetrics) = 0;
    virtual bool
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aFlags) = 0;
    virtual bool
    RecvUpdateZoomConstraints(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const MaybeZoomConstraints& aConstraints) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PAPZParent();

    virtual ~PAPZParent();

    PContentParent*
    Manager() const;

    PAPZ::State
    state();

    MOZ_WARN_UNUSED_RESULT bool
    SendUpdateFrame(const FrameMetrics& frame);

    MOZ_WARN_UNUSED_RESULT bool
    SendHandleDoubleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid);

    MOZ_WARN_UNUSED_RESULT bool
    SendHandleSingleTap(
            const CSSPoint& aPoint,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const bool& aCallTakeFocusForClickFromTap);

    MOZ_WARN_UNUSED_RESULT bool
    SendHandleLongTap(
            const CSSPoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyAPZStateChange(
            const ViewID& aViewId,
            const APZStateChange& aChange,
            const int& aArg);

    MOZ_WARN_UNUSED_RESULT bool
    SendNotifyFlushComplete();

    MOZ_WARN_UNUSED_RESULT bool
    SendDestroy();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual base::ProcessId
    OtherPid() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    void
    OnProcessingError(
            Result aCode,
            const char* aReason);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    MOZ_NEVER_INLINE void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            void** iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            PAPZParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_WARN_UNUSED_RESULT bool
    Read(
            PAPZParent** v__,
            const Message* msg__,
            void** iter__,
            bool nullable__);

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZParent :
    public PAPZParent
{
    virtual bool
    RecvUpdateHitRegion(const nsRegion& aRegion);

    virtual bool
    RecvZoomToRect(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const CSSRect& aRect,
            const uint32_t& aFlags);

    virtual bool
    RecvContentReceivedInputBlock(
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId,
            const bool& aPreventDefault);

    virtual bool
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& aTargets);

    virtual bool
    RecvStartScrollbarDrag(const AsyncDragMetrics& aDragMetrics);

    virtual bool
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aFlags);

    virtual bool
    RecvUpdateZoomConstraints(
            const uint32_t& aPresShellId,
            const ViewID& aViewId,
            const MaybeZoomConstraints& aConstraints);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT APZParent();
    virtual ~APZParent();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
bool
APZParent::RecvUpdateHitRegion(const nsRegion& aRegion)
{
    return false;
}

bool
APZParent::RecvZoomToRect(
        const uint32_t& aPresShellId,
        const ViewID& aViewId,
        const CSSRect& aRect,
        const uint32_t& aFlags)
{
    return false;
}

bool
APZParent::RecvContentReceivedInputBlock(
        const ScrollableLayerGuid& aGuid,
        const uint64_t& aInputBlockId,
        const bool& aPreventDefault)
{
    return false;
}

bool
APZParent::RecvSetTargetAPZC(
        const uint64_t& aInputBlockId,
        nsTArray<ScrollableLayerGuid>&& aTargets)
{
    return false;
}

bool
APZParent::RecvStartScrollbarDrag(const AsyncDragMetrics& aDragMetrics)
{
    return false;
}

bool
APZParent::RecvSetAllowedTouchBehavior(
        const uint64_t& aInputBlockId,
        nsTArray<TouchBehaviorFlags>&& aFlags)
{
    return false;
}

bool
APZParent::RecvUpdateZoomConstraints(
        const uint32_t& aPresShellId,
        const ViewID& aViewId,
        const MaybeZoomConstraints& aConstraints)
{
    return false;
}

void
APZParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT APZParent::APZParent()
{
    MOZ_COUNT_CTOR(APZParent);
}

MOZ_IMPLICIT APZParent::~APZParent()
{
    MOZ_COUNT_DTOR(APZParent);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZParent_h
